#include <stdio.h>

extern "C" {
    void VMProtectBeginVirtualization( const char* );
    void VMProtectEnd();
}

#pragma clang optimize off
void tryThreadLocal( int x )
{
    printf("inside tryThreadLocal()\n");
    static thread_local int data = 0;
    printf( "data + x = %d\n", data + x );
}

void test( int& x )
{
    VMProtectBeginVirtualization( "" );
        ++x;
        tryThreadLocal( x );
    VMProtectEnd();
}

int main()
{
    int x = 0;
    test( x );
    printf("x = %d\n", x);

    return 0;
}
#pragma clang optimize on
